/***************************************************************************
 *   Copyright (C) 2007 by Antony Martin                                   *
 *   martin.antony@yahoo.fr                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

/* Cree le : 31 janvier 2006
   derniere modification le 15/05/2007 */


/* detection, chargement et renvoie des capacitees
   disponible sur l'implementation */


#include <SCE/SCEMinimal.h>

#include <SCE/core/SCECSupport.h>


static unsigned char caps[SCE_NCAPS];


static void SCE_CCheckCaps(void)
{
    caps[SCE_TEX_MULTI] =
    glewIsSupported("GL_ARB_multitexture");
    
    caps[SCE_TEX_NON_POWER_OF_TWO] =
    glewIsSupported("GL_ARB_texture_non_power_of_two");
    
    caps[SCE_TEX_HW_GEN_MIPMAP] =
    glewIsSupported("GL_SGIS_generate_mipmap");
    
    caps[SCE_TEX_DXT1] = caps[SCE_TEX_DXT3] = caps[SCE_TEX_DXT5] =
    glewIsSupported("GL_ARB_texture_compression") &&
    glewIsSupported("GL_EXT_texture_compression_s3tc");
    
    caps[SCE_TEX_S3TC] =
    glewIsSupported("GL_EXT_texture_compression_s3tc");
    
    caps[SCE_TEX_3DC] = 0;
    
    caps[SCE_VBO] =
    glewIsSupported("GL_ARB_vertex_buffer_object");
    
    caps[SCE_FBO] =
    glewIsSupported("GL_EXT_framebuffer_object");
    
    caps[SCE_PBO] =
    glewIsSupported("GL_EXT_pixel_buffer_object") ||
    glewIsSupported("GL_ARB_pixel_buffer_object");
    
    caps[SCE_VERTEX_GLSL_SHADER] =
    glewIsSupported("GL_ARB_vertex_shader") &&
    glewIsSupported("GL_ARB_shader_objects") &&
    glewIsSupported("GL_ARB_shading_language_100");
    
    caps[SCE_FRAGMENT_GLSL_SHADER] =
    glewIsSupported("GL_ARB_fragment_shader") &&
    glewIsSupported("GL_ARB_shader_objects") &&
    glewIsSupported("GL_ARB_shading_language_100");
    
    caps[SCE_VERTEX_ASM_PROGRAM] =
    glewIsSupported("GL_ARB_vertex_program");
    
    caps[SCE_FRAGMENT_ASM_PROGRAM] =
    glewIsSupported("GL_ARB_fragment_program");
    
    #if 0
    caps[SCE_CG_SHADERS] =
    glewIsSupported("..."); /* NOTE: a completer... ou pas ? les Cg sont peut etre de "toute facon" supportes */
    #endif
    caps[SCE_CG_SHADERS] = 0;
    
    caps[SCE_OCCLUSION_QUERY] =
    glewIsSupported("GL_ARB_occlusion_query");
}

int SCE_CSupportInit(void)
{
    /* recherche des extensions supportees */
    SCE_CCheckCaps();
    
    /* cool */
    return (SCE_OK);
}


int SCE_CSupport(const char *ext)
{
    /* chercher dans la liste perso... glGetString(GL_EXTENSIONS); */
    ext = NULL;
    return (SCE_OK);
}


int SCE_CGlewSupport(const char *ext)
{
    return (glewIsSupported(ext));
}


int SCE_CHasCap(SCE_CCap cap)
{
    int result = 0;
    
    result = caps[cap];
    
    return (result);
}

