/***************************************************************************
 *   Copyright (C) 2007 by Antony Martin                                   *
 *   martin.antony@yahoo.fr                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

/* Cree le : 7 mars 2006
   derniere modification le 16/03/2007 */


#include <SCE/SCEMinimal.h>

/* CTypes.h est inclu dans Minimal.h */


size_t SCE_CSizeofType(SCEenum type)
{
    switch(type)
    {
        case SCE_DOUBLE:
            return (sizeof(GLdouble));
        
        case SCE_FLOAT:
            return (sizeof(GLfloat));
        
        case SCE_INT:
        case SCE_UNSIGNED_INT:
            return (sizeof(GLint));
        
        case SCE_SHORT:
        case SCE_UNSIGNED_SHORT:
            return (sizeof(GLshort));
        
        case SCE_BYTE:
        case SCE_UNSIGNED_BYTE:
            return (sizeof(GLbyte));
        
        #ifdef __SCE_DEBUG__
        default:
            Logger_Log(SCE_INVALID_ARG);
            Logger_LogMsg("unknow data type");
        #endif
    }
    
    return (0);
}


unsigned int SCE_CGetGLMaxTextureUnits(void)
{
    static int units = -1;
    
    if(units == -1)
        glGetIntegerv(GL_MAX_TEXTURE_UNITS, &units);
    
    return (units);
}
